#ifndef __IMG_H
#define __IMG_H

#include "png.h"
/*
 * simplize loading png
 *
 * au: vitas
 * cp: gpl
 */

typedef long long int t_lfval;

typedef struct t_linefield
{
  int w, h, delta;
  int mapx, mapy;
  int mapxy;
  t_lfval sum;
  t_lfval max;
  t_lfval prah;
  t_lfval *map;
} t_linefield;

typedef struct t_lineinterval
{
  int ymin, ymax, zmin, zmax;
  int fsty, fstz;
  int xmin, xmax;
} t_lineinterval; /* t_lineinterval */

typedef struct t_li_set
{
  int top;
  int siz;
  t_lineinterval *m;
} t_li_set;


typedef struct t_rgba {
  unsigned short int r, g, b, a;
} t_rgba;

typedef struct t_img
{
  png_uint_32 w, h, rb;
  png_bytep *r; /* radky */
  png_bytep b; /* vse */
  int dep;
  int curx, cury;
  int is_rot;
} t_img;

typedef struct t_font
{
  int w, h;
  int fstchar, lstchar;
  char *map;
} t_font;

extern t_font *font;
extern t_rgba font_bg_col;
extern t_rgba font_fg_col;

t_img*	img_new(png_uint_32 w, png_uint_32 h, int dep);
void	img_del(t_img *img);
t_img*	img_png_read(char *filename);
int	img_png_write(char *filename, t_img *img);
t_img*	img_gray2rgb(t_img *img);
void	img_putpixel(t_img *img, int x, int y, t_rgba rgba);
void	img_vline(t_img *img, int x1, int x2, int y, t_rgba rgba);
void	img_rect(t_img *img, int x0, int y0, int w, int h, t_rgba rgba);
void	img_line(t_img *img, int x0, int y0, int x1, int y1, t_rgba rgba);
t_img*	img_rot(t_img *img);
void	img_is_rot(t_img *img);
void	img_line_jenkdeje(
        	t_img *img,
        	t_img *img2,
        	int vaha,
        	int x0, int y0, int x1, int y1,
        	t_rgba rgba);
t_img*	lf_to_img(t_linefield* lf);
void	lf_img_puntiky(t_linefield *lf, t_li_set *lis,  t_img *img);

void img_putc(t_img *img, int x, int y, int c);
void img_puts(t_img *img, int x, int y, char *s);


t_font*	img_load_font(char *filename);
void img_printchar(t_img *img, char c, t_rgba rgba);
void img_printf(t_img*img, t_rgba rgba, char *fmt, ...);
#endif
