#!/bin/sh

if [ "$#" -lt 1 ] ; then
	echo "usage:$0 infile.ti [ + [ + [ + ] ] ]" 
	echo "    i'th plus skips i'th phase"
	exit 0
fi

F1=$2
F2=$3
F3=$4
FILE=$1
FILE=${FILE%.ti}.ti
FILEWO=${FILE%.ti}
DIR=$FILEWO
FILEPARAM=$FILEWO.param
FILELOG=$FILEWO.log

ENDFRAME=`m4 -D__count_frames title.m4 $FILE`
ENDFRAMEF=`printf "%04i" $ENDFRAME`


#faze 1: generovani obrazku

rm -f $FILELOG

echo "FILE: $FILE FILEWO:$FILEWO DIR:$DIR" |
tee -a $FILELOG
echo "ENDFRAME: $ENDFRAME($ENDFRAMEF) FILEPARAM: $FILEPARAM  F1-3:$F1:$F2:$F3" |
tee -a $FILELOG

echo "#### faze 1: generovani obrazku"|tee -a $FILELOG

if [ "$F1" != "+" ] ; then
	./title.sh + $FILE 2>&1|tee -a $FILELOG
fi

#faze 2: converze obrazku do pnm
echo "##### faze 2: converze obrazku do pnm" | tee -a $FILELOG

if [ "$F2" != "+" ] ; then
	./png2jpg.sh $DIR 0 $ENDFRAME 2>&1|tee -a $FILELOG

fi

#faze 3: vytvoreni mpgu
echo "#### faze 3: vytvoreni mpgu"  | tee -a $FILELOG

if [ "$F3" != "+" ] ; then

cat  <<EOF >$FILEPARAM

PATTERN		IIIIIIII
OUTPUT		$FILEWO.mpg

#    YUV, PPM, JMOVIE, Y, JPEG, PNM
BASE_FILE_FORMAT	PNM
# INPUT_FORMAT UCB
INPUT_CONVERT	*
GOP_SIZE	8
SLICES_PER_FRAME	1
INPUT_DIR	$DIR

INPUT
$FILEWO.*.pnm	[0000-$ENDFRAMEF]
END_INPUT

PIXEL		HALF
RANGE		16
PSEARCH_ALG	LOGARITHMIC
BSEARCH_ALG	SIMPLE
IQSCALE		8
PQSCALE		10
BQSCALE		25
REFERENCE_FRAME	DECODED
BIT_RATE  5000000
#BUFFER_SIZE 1310720
BUFFER_SIZE 327680
FRAME_RATE 24

EOF

	mpeg_encode $FILEPARAM 2>&1|tee -a $FILELOG

fi

echo "$FILEWO.mpg done (asi) log je v $FILELOG"
