#include <stdio.h>
#include "img.h"
#include <ctype.h>
#include <string.h>
#include <assert.h>
#include <stdarg.h>
#include <unistd.h>

/*
 * txt2png -- prevod textu do obrazku, + posun kurzoru, + barvicky 
 *
 * au: vitas
 * cp: gpl
 */


int is_debug = 0;

t_rgba
	col_black      = { 0,      0,      0, 0},
	col_red        = { 0xaaaa, 0,      0, 0},
	col_green      = { 0,      0xaaaa, 0, 0},
	col_brown      = { 0xaaaa, 0x5555, 0, 0},
	col_blue       = { 0,      0,      0xaaaa, 0},
	col_magenta    = { 0xaaaa, 0,      0xaaaa, 0},
	col_cyan       = { 0,      0xaaaa, 0xaaaa, 0},
	col_white      = { 0xaaaa, 0xaaaa, 0xaaaa, 0},

	col_black_br   = { 0x5555, 0x5555, 0x5555, 0},
	col_red_br     = { 0xffff, 0x0,    0x0, 0},
	col_green_br   = { 0x5555, 0xffff, 0x5555, 0},
	col_brown_br   = { 0xffff, 0xffff, 0x5555, 0},
	col_blue_br    = { 0x5555, 0x5555, 0xffff, 0},
	col_magenta_br = { 0xffff, 0x5555, 0xffff, 0},
	col_cyan_br    = { 0x5555, 0xffff, 0xffff, 0},
	col_white_br   = { 0xffff, 0xffff, 0xffff, 0},

	col_bg_default = { 0, 0, 0, 0},
	col_fg_default = { 0x8000, 0x8000, 0x8000, 0};

int       font_br = 1;
const int font_br_default = 1;

int cursor_x = 0 , cursor_y = 0;
t_img *img;

void
deb(const char *fmt,...)
{
        va_list ap;

	if( is_debug )
	{

		va_start(ap, fmt);
		vfprintf(stderr, fmt, ap);
		fprintf(stderr, "\n");
		va_end(ap);
	}
} /* err*/



void
render_cr()
{
	cursor_x = 0;

	if( cursor_y + 2 *  font->h > img->h )
	{ /* je nutno odscrolovat */
		img_rect(img, 0, 0, img->w, font->h, col_bg_default);
		img_vscroll(img, font->h);
	}
	else
	{ /* jinak se jen posunu */
		cursor_y += font->h;
	}
} /* render_cr */

void
render_lf()
{
	cursor_x = 0;
} /* render_cr */

void
render_bs()
{
	cursor_x -= font->w;
	if( cursor_x < 0 )
	{
		cursor_x = 0;
	}
} /* render_bs */

void
render_one(int zn)
{
	img_putc(img, cursor_x, cursor_y, zn);
	cursor_x += font->w;
} /* render_one */

void
render_cursor()
{
	render_one('_');
} /* render_cursor */

/*
 * udela tabulator (jen prekoci)
 * pokud je by mel preskocit konec, odeteruje
 */
void
render_tab()
{
	int nas;

	nas = font->w * 8;

	cursor_x = ( ( cursor_x / nas ) + 1 ) * nas;
	if( cursor_x + font->w >  img->w )
	{
		render_cr();
	}
} /* render_tab */

void
render_esc_sqb_H(int row, int col)
{
	cursor_x = (col-1) * font->w;
	cursor_y = (row-1) * font->h;
} /* render_esc_sqb_H */

void
render_esc_sqb_m_one(int a1)
{
	deb("render_esc_sqb_m_one:%i\n", a1);

	switch(a1)
	{
	case 0:
		font_bg_col = col_bg_default;
		font_fg_col = col_fg_default;
		font_br = font_br_default;
		break;
	case 21:
		font_br = 0;
		break;
	case 1:
		font_br = 1;
		break;

#define FCOL(c) font_fg_col = font_br ? col_##c##_br : col_##c
#define BCOL(c) font_bg_col = col_##c
	case 30:
		FCOL(black);
		break;
	case 31:
		FCOL(red);
		break;
	case 32:
		font_fg_col = col_green_br;
		break;
	case 33:
		FCOL(brown);
		break;
	case 34:
		FCOL(blue);
		break;
	case 35:
		FCOL(magenta);
		break;
	case 36:
		FCOL(cyan);
		break;
	case 37:
		FCOL(white);
		break;
	case 40:
		font_bg_col = col_black;
		break;
	case 41:
		BCOL(red);
		break;
	case 42:
		BCOL(green);
		break;
	case 43:
		BCOL(brown);
		break;
	case 44:
		BCOL(blue);
		break;
	case 45:
		BCOL(magenta);
		break;
	case 46:
		BCOL(cyan);
		break;
	case 47:
		BCOL(white);
		break;
	default:
		/* hm. */
		break;
		
	}
} /* render_esc_sqb_m */

void
render_esc_sqb_m(int argc, int *argv)
{
	int i;
	for(i = 0; i <= argc; i++)
	{
		render_esc_sqb_m_one(argv[i]);
	}
} /* render_esc_sqb_m */

void
render_esc_sqb(FILE *f)
{
	int argv[16];
	int argc;
	int zn;
	
	/* vycisti `argv' */
	for(argc = 16; argc--; argv[argc] = 0);

	argc = 0;

	/* nacti argumenty escapu */
	while(1)
	{
		zn = fgetc(f);
		if( isdigit (zn) )
		{
			argv[argc] *= 10;
			argv[argc] += zn - '0';
			continue;
		}
		if( zn == '?' )
		{
			argv[argc] = - argv[argc];
			continue;
		}
		if( zn == ';' ) 
		{
	deb("render_esc_sqb: argv[%i] = %i \n", argc, argv[argc]);
			argc++;
			assert(argc < 16);
			continue;
		}
		break;
	}
	deb("render_esc_sqb: argv[%i] = %i \n", argc, argv[argc]);
	deb("render_esc_sqb: esc%c\n", zn);

	switch(zn)
	{
	case 'H':
		render_esc_sqb_H(argv[0], argv[1]);
		break;
	case 'm':
		render_esc_sqb_m(argc, argv);
		break;
	default:
		/* unknown esc, hmm, forget it */
	}
			

} /* render_esc_sqb */

void
render_esc_c()
{
	img_rect(img, 0, 0, img->w, img->h, col_bg_default);
	cursor_x =
	cursor_y = 0;
} /* render_esc_c */

void
render_esc(FILE *f)
{
	int zn;

	zn = fgetc(f);

	switch(zn)
	{
	case '[':
		render_esc_sqb(f);
		break;
	case 'c':
		render_esc_c();
		break;
	}

}
/*
 * main loop, proces all the file
 */
void
render(FILE *f)
{
	int zn;

	while(1)
	{
		zn = fgetc(f);

		switch( zn )
		{
		case 0x1b: /* escape */
			render_esc(f);
			break;
		case '\n':
			render_cr();
			break;
		case '\r':
			render_lf();
			break;
		case '\t':
			render_tab();
			break;
		case '\a':
			render_cursor();
			break;
		default:
			render_one(zn);
			break;
		case EOF:
			return;
		}
	}

} /* render */

int
usage()
{
	printf(
"usage: txt2png [-f Font] [-s XxY] [-S XxY] [-d] [in.txt [out.png]]\n"
"       -f font load font Font (not gziped)\n"
"       -s picture size in chars\n"
"       -S picture size in pixels (640x480)\n"
"       -d debug\n"
"       default filenames are \"in.txt\" and \"out.png\"\n"
"       -h this help\n\n");
	return 0;
} /* usage */

int 
main(int argc, char *argv[])
{
	FILE *fin;

	char *fin_name = "in.txt";
	char *fout_name = "out.png";
	char *font_name = "iso02.f16.psf";
	int size_by_chars = 0;
	int pic_w = 640 , pic_h = 480;

	int zn;



	while( -1 != (zn = getopt(argc, argv, "df:s:S:")))
	{
		switch(zn)
		{
		case 's':
			sscanf(optarg, "%ix%i", &pic_w, &pic_h);
			size_by_chars = 1;
			break;

		case 'S':
			sscanf(optarg, "%ix%i", &pic_w, &pic_h);
			size_by_chars = 0;
			break;
		case 'f':
			font_name = optarg;
			break;
		case 'd':
			is_debug = 1;
			break;
		default:
			return usage();
		}
	}

	argc -= optind;
	argv += optind;

	if( argc > 2 )
	{
		return usage();
	}

	if( argc >= 1 )
	{
		fin_name = argv[0];
	}

	if( argc == 2 )
	{
		fout_name = argv[1];
	}


	if( strcmp(fin_name, "-") == 0 )
	{
		fin = stdin;
	}
	else 
	{
		fin = fopen(fin_name, "rt");
	}
	assert(fin);

	font = img_load_font(font_name);
	assert(font);

	if( size_by_chars )
	{
		pic_w *= font->w;
		pic_h *= font->h;
	}

	img = img_new(pic_w, pic_h, 6);
	assert(img);

	render_esc_sqb_m_one(0);

	render(fin);

	img_png_write(fout_name, img);

	return 0;
} /* main */

