#!/bin/sh

DELAY="sleep  0.02"
if [ "$1" = "+" ] ; then DELAY="read LINE"; shift; fi

if [ "$#" -lt 1 ] ; then
	echo "usage:$0 + file.ti [ beg-frame [ end-frame ] ]"
	exit 0
fi

echo 1

LINES=18
COLS=44

RULER="----+----1----+----2----+----3----+----4----+----5----+----6----+----7----+----8"
RULER=`echo "$RULER"|sed 's/^\(.\{'$COLS'\}\).*$/\1I/'`

FILE=$1
FILE=${FILE%.ti}.ti
DIR=${FILE%.ti}
FRAME=$2
ENDFRAME=$3

BEGSEC=`date +%s`

LINESpp=$((LINES+1))


if [ -z "$FRAME" ] ; then FRAME=0; fi
echo 2

if [ -z  "$ENDFRAME" ] ; then 
	ENDFRAME=`m4 -D__count_frames title.m4 $FILE`
fi

echo "3 ENDFRAME: $ENDFRAME FILE: $FILE"

echo "printing ^[(K...(K done"

while [ "$FRAME" -le "$ENDFRAME" ] ; do
	FRAMEF=`printf "%04i" $FRAME`
	echo -n "c(K"

	FRAMEFILE="$DIR/${DIR}.$FRAMEF.txt"

	FRAMELINES=`wc -l $FRAMEFILE`
	NOWSEC=`date +%s`
	REALSEC=$(($NOWSEC - $BEGSEC))

	tail -n $LINES $FRAMEFILE
	#tail -n 50 $FRAMEFILE

	echo     "[${LINESpp};1H$RULER"
	echo -n  "[fr:$FRAME film sec: $((FRAME/24))"
	echo     "real sec: $REALSEC] lines: $FRAMELINES"
	$DELAY
	FRAME=`expr $FRAME + 1`

done

echo "printing ^[(K...(K done"
